# FixedArray

[![Build Status](https://travis-ci.org/asdf404/fixed-length-array.svg?branch=master)](https://travis-ci.org/asdf404/fixed-length-array)
[![Coverage Status](https://coveralls.io/repos/asdf404/fixed-length-array/badge.svg?branch=master)](https://coveralls.io/r/asdf404/fixed-length-array?branch=master)
[![Code Climate](https://codeclimate.com/github/asdf404/fixed-length-array.svg)](https://codeclimate.com/github/aasdf404/fixed-length-array)
[![NPM version](https://img.shields.io/npm/v/fixed-length-array.svg)]()

[![Standard - JavaScript Style Guide](https://cdn.rawgit.com/feross/standard/master/badge.svg)](https://github.com/feross/standard)

```sh
npm install fixed-length-array --save
```

## Usage

`FixedArray` inherits native `Array` class and all its methods.

```js
import FixedArray from 'fixed-length-array'

new FixedArray(2) // [ , ]
new FixedArray(1, 2) // [ 1, 2 ] — yep, as native Array
FixedArray.from([ 1, 2 ]) // [ 1, 2 ]

function gen() {
  yield 1
  yield 2
}
FixedArray.from(gen()) // [ 1 , 2 ]
```

Methods `push()` and `unshift()` works different. If you create an array with fixed length it keeps his length, so methods `push()` and `unshift()` will remove elements from other end of array (`shift()` and `pop()` respectively). Methods `pop()` and `shift()` is not accesible manually.

```js
const array = FixedArray.from([ 1, 2 ])
console.log(array.length) // 2
array.push(3)
console.log(array.length) // 2 — length not changed
console.log(array) // [ 2, 3 ]

array.unshift(1)
console.log(array.length) // still 2
console.log(array) // [ 1, 2 ]
```

As you can see `FixedArray` is not resizable. Only way to resize is create new `FixedArray`.

## License

[MIT](LICENSE)
